package ex_nodecrud.view
{
	import ex_nodecrud.ApplicationFacade;
	
	import org.puremvc.as3.interfaces.IMediator;
	import org.puremvc.as3.interfaces.INotification;
	import org.puremvc.as3.patterns.mediator.Mediator;

	public class EditorMediator extends Mediator implements IMediator
	{
		public static const NAME:String = "EditorMediator";
		private var node:Object;
		private var creationMode:Boolean;
		
		public function EditorMediator(viewComponent:EditorPanel, node:Object)
		{
			super(NAME, viewComponent);
			
			// Create/Update mode
			creationMode = node == null;
			
			// Init view
			if (creationMode)
				cView.currentState = "create";
			else
			{
				cView.currentState = "update";
				this.node = node;
			}
		}
		
		override public function listNotificationInterests():Array
		{
			return [ApplicationFacade.OPENEDITOR_COMPLETE];
		}
		
		override public function handleNotification(note:INotification):void
		{
			switch (note.getName())
			{
				case ApplicationFacade.OPENEDITOR_COMPLETE:
					// Load data
					if (!creationMode)
					{
						cView.nid.text = node.nid;
						cView.txtTitle.text = node.title;
						cView.txtBody.text = node.body;
					}
					break;
			}
		}
		
		public function get cView():EditorPanel
		{
			return viewComponent as EditorPanel;
		}
	}
}
